=== debian/changelog ===
ros-bouncy-fastrtps (1.6.0-5bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 17 Jul 2018 00:17:50 -0000
